jQuery(document).ready(function($) {
    var dhlparcel_shipping_bulk_profiles_template = null;

    $(document.body).on('dhlparcel_shipping:add_test_authenticate_button', function(e) {
        if ($('#DHLPARCEL_SHIPPING_TEST_AUTHENTICATE_BUTTON').length > 0) {
            $('#DHLPARCEL_SHIPPING_TEST_AUTHENTICATE_BUTTON')
                .closest('.form-group')
                .removeClass('hide')
                .html(dhlparcel_shipping_authenticate_template);
        }
    }).on('dhlparcel_shipping:set_ccc_mode', function(e) {
        if (!dhlparcel_shipping_ccc_mode_select_enabled && $('#DHLPARCEL_SHIPPING_CCC_MODE').length > 0) {
            $('#DHLPARCEL_SHIPPING_CCC_MODE').val(+dhlparcel_shipping_ccc_mode_enabled);
        }
    }).on('click', '#dhlparcel_shipping_settings_authenticate', function(e) {
        e.preventDefault();

        var user_id = $("#DHLPARCEL_SHIPPING_API_USER_ID").val();
        var key = $("#DHLPARCEL_SHIPPING_API_KEY").val();

        var data = $.extend(true, $(this).data(), {
            user_id: user_id,
            key: key
        });

        $('#dhlparcel_shipping_settings_authenticate').html(dhlparcel_shipping_authenticate_loading_message);
        // Disable button
        $('#dhlparcel_shipping_settings_authenticate').removeClass('dhlparcel_shipping_authenticate_button_success');
        $('#dhlparcel_shipping_settings_authenticate').removeClass('dhlparcel_shipping_authenticate_button_error');
        $('#dhlparcel_shipping_settings_authenticate').prop("disabled", true);

        $.post(dhlparcel_shipping_backoffice_ajax_authenticate, data, function (response) {

            try {
                var status = response.status;
                var message = response.message;
                var accounts = response.data.accounts;
            } catch (error) {
                alert('Error');
                return;
            }

            // Enable button
            $('#dhlparcel_shipping_settings_authenticate').prop("disabled", false);

            var dhlparcel_shipping_account_area = $('input#DHLPARCEL_SHIPPING_API_ACCOUNT_ID').parent();
            dhlparcel_shipping_account_area.children('div.dhlparcel_shipping_settings_suggestion_info').remove();
            dhlparcel_shipping_account_area.children('div.dhlparcel_shipping_settings_suggestion_accounts').remove();

            $('#dhlparcel_shipping_settings_authenticate').html(message);

            if (status === 'success') {
                $('#dhlparcel_shipping_settings_authenticate').addClass('dhlparcel_shipping_authenticate_button_success');

                if (!$.isEmptyObject(accounts)) {
                    dhlparcel_shipping_account_area.append('<div class="dhlparcel_shipping_settings_suggestion_info">' + dhlparcel_shipping_authenticate_accounts_message + '</div>');
                    $.each(accounts, function (index, value) {
                        dhlparcel_shipping_account_area.append('<div class="dhlparcel_shipping_settings_suggestion_accounts" data-account-id="' + value.toString() + '">' + value.toString() + '</div>');
                    });

                    // Autofill account if empty
                    if ($('input#DHLPARCEL_SHIPPING_API_ACCOUNT_ID').val().length === 0) {
                        var value = accounts[0];
                        $('input#DHLPARCEL_SHIPPING_API_ACCOUNT_ID').val(value);
                    }
                }

            } else {
                $('#dhlparcel_shipping_settings_authenticate').addClass('dhlparcel_shipping_authenticate_button_error');
            }

        }, 'json');

    }).on('click', '.dhlparcel_shipping_settings_suggestion_accounts', function(e) {
        var account_id = $(this).data('account-id');
        $('input#DHLPARCEL_SHIPPING_API_ACCOUNT_ID').val(account_id);

    }).on('dhlparcel_shipping:add_bulk_subtitle', function(e) {
        if ($('#DHLPARCEL_SHIPPING_BULK_SUBTITLE').length > 0) {
            $('#DHLPARCEL_SHIPPING_BULK_SUBTITLE')
                .closest('.form-group')
                .removeClass('hide')
                .html(dhlparcel_shipping_bulk_subtitle_template);
        }

    }).on('dhlparcel_shipping:init_bulk_profile_template', function(e) {
        if (dhlparcel_shipping_bulk_profiles_template === null) {
            $.get(dhlparcel_shipping_bulk_profiles_template_link, function (response) {
                try {
                    var view = response.data.view;
                } catch (error) {
                    // Something went wrong
                    return;
                }

                dhlparcel_shipping_bulk_profiles_template = view;
                $(document.body).trigger('dhlparcel_shipping:load_bulk_profile_template');
            });
        }

    }).on('dhlparcel_shipping:load_bulk_profile_template', function(e) {
        // Load basic template if not done yet
        if ($('#DHLPARCEL_SHIPPING_BULK_PROFILES').length > 0) {

            // Load template
            $('#DHLPARCEL_SHIPPING_BULK_PROFILES')
                .closest('.form-group')
                .removeClass('hide')
                .html(dhlparcel_shipping_bulk_profiles_template);
        }

        $('#dhlparcel_shipping_settings_bulk_profile_form_unavailable').show();
        $('#dhlparcel_shipping_settings_bulk_profile_form_container').hide();

        $(document.body).trigger('dhlparcel_shipping:fill_bulk_profile_template');

    }).on('dhlparcel_shipping:refresh_bulk_profile_template', function(e, search_code, retry = false) {
        var search_profile = null;
        try {
            var bulk_profiles_json = JSON.parse($('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val());
            $.each(bulk_profiles_json, function (index, bulk_profile_json) {
                if (search_code === bulk_profile_json.code) {
                    search_profile = {
                        code: bulk_profile_json.code,
                        country: bulk_profile_json.country,
                        business: bulk_profile_json.business,
                        delivery: bulk_profile_json.delivery,
                        options: bulk_profile_json.options,
                        required_options: bulk_profile_json.required_options,
                        size: bulk_profile_json.size
                    };
                }
            });
        } catch (e) {
            // Stop loading if not a valid JSON
            return;
        }

        if (search_profile === null) {
            return;
        }

        // Set loading animation
        $('#dhlparcel_shipping_sbpf_country').prop('disabled', true);
        $('#dhlparcel_shipping_sbpf_shipment_type').prop('disabled', true);
        $('#dhlparcel_shipping_sbpf_delivery_type').prop('disabled', true);
        $('#dhlparcel_shipping_sbpf_size').prop('disabled', true);
        $('#dhlparcel_shipping_panel_service_options').html('<img src="/modules/dhlparcel_shipping/assets/images/dhlparcel_shipping_ajax_loader.gif" id="dhlparcel_shipping_ajax_loader" alt="Loading">');

        // Get values
        var data = {
            receiverCountry: search_profile.country,
            shipmentType: search_profile.business,
            deliveryType: search_profile.delivery
        };

        $.post(dhlparcel_shipping_bulk_profiles_search_link, data, function (response) {
            try {
                var message = response.message;
                var deliveryTypeView = response.data.view.deliveryType;
                var serviceOptionsView = response.data.view.serviceOptions;
                var sizesView = response.data.view.sizes;
            } catch (error) {
                alert('Error');
                return;
            }

            // Update html
            $('#dhlparcel_shipping_sbpf_delivery_type').html(deliveryTypeView);
            $('#dhlparcel_shipping_panel_service_options').html(serviceOptionsView);
            $('#dhlparcel_shipping_sbpf_size').html(sizesView);

            $('#dhlparcel_shipping_sbpf_country').prop('disabled', false);
            $('#dhlparcel_shipping_sbpf_shipment_type').prop('disabled', false);
            $('#dhlparcel_shipping_sbpf_delivery_type').prop('disabled', false);
            $('#dhlparcel_shipping_sbpf_size').prop('disabled', false);

            // Fill in form
            $('#dhlparcel_shipping_settings_bulk_profile_form_container').data('bulk-profile-code', search_profile.code);
            $('#dhlparcel_shipping_sbpf_country').val(search_profile.country);
            $('#dhlparcel_shipping_sbpf_shipment_type').val(search_profile.business);
            $('#dhlparcel_shipping_sbpf_delivery_type').val(search_profile.delivery);

            // Reset services
            $("#dhlparcel_shipping_panel_service_options :input").each(function() {
                $(this).attr('disabled', false);
                $(this).attr('checked', false);
            });

            $.each(search_profile.options, function (index, value) {
                $("input.dhlparcel_shipping_panel_service_option[value='" + value + "']").attr('checked', true);
            });
            $.each(search_profile.required_options, function (index, value) {
                $("input.dhlparcel_shipping_panel_service_roption[value='" + value + "']").attr('checked', true);
            });

            $('#dhlparcel_shipping_sbpf_size').val(search_profile.size);


            // Check if profiles are equal
            if (search_profile.size !== $('#dhlparcel_shipping_sbpf_size').val() || search_profile.delivery !== $('#dhlparcel_shipping_sbpf_delivery_type').val()) {
                if (retry) {
                    // This was already a retry attempt, skip retrying
                    return;
                }

                if ($('#dhlparcel_shipping_sbpf_size').val() === null || $('#dhlparcel_shipping_sbpf_delivery_type').val() === null) {
                    // Also exit if capabilities are zero
                    return;
                }

                // Cannot load anything, reset options and retry
                $(document.body).trigger('dhlparcel_shipping:save_bulk_profile', [true]);
                $(document.body).trigger('dhlparcel_shipping:refresh_bulk_profile_template', [search_code, true]);
                return;
            }

            // Show form
            $('#dhlparcel_shipping_settings_bulk_profile_form_unavailable').hide();
            $('#dhlparcel_shipping_settings_bulk_profile_form_container').show();

            $(document.body).trigger('dhlparcel_shipping:disable_settings_service_option_exclusions');
        });

    }).on('change', "#dhlparcel_shipping_settings_bulk_profile_menu_container input[name='dhlparcel_shipping_setting_bulk_profile_menu']", function(e) {
        // Get bulk data from hidden input
        var search_code = $(this).val();

        // Update form
        $(document.body).trigger('dhlparcel_shipping:refresh_bulk_profile_template', [search_code]);

    }).on('dhlparcel_shipping:clean_bulk_profile_template', function(e) {
        $('#dhlparcel_shipping_settings_bulk_profile_menu_container').html('');

    }).on('dhlparcel_shipping:fill_bulk_profile_template', function(e) {
        // Add menu add button
        $('#dhlparcel_shipping_settings_bulk_profile_menu_container').append(dhlparcel_shipping_bulk_profile_menu_add_template);

        try {
            var bulk_profiles_json = JSON.parse($('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val());
            var bulk_profiles = [];
            $.each(bulk_profiles_json, function (index, bulk_profile_json) {
                var bulk_profile = {
                    code: bulk_profile_json.code,
                    country: bulk_profile_json.country,
                    business: bulk_profile_json.business,
                    delivery: bulk_profile_json.delivery,
                    options: bulk_profile_json.options,
                    required_options: bulk_profile_json.required_options,
                    size: bulk_profile_json.size
                };
                bulk_profiles.push(bulk_profile);
            });

        } catch (e) {
            // Stop loading if not a valid JSON
            return;
        }

        if (bulk_profiles.length === 0) {
            return;
        }

        // Set values
        // Fill profile menu
        $.each(bulk_profiles_json, function (index, bulk_profile) {
            var text = '[' + bulk_profile.country.toUpperCase() + '] ' + bulk_profile.size.toUpperCase();
            var sub = bulk_profile.business === '' ? '' : 'To ' + bulk_profile.business + ': ';
            if (bulk_profile.delivery === 'BP') {
                sub += 'Mailbox delivery ';
            }
            if (bulk_profile.options.length > 0) {
                sub += '(';
                $.each(bulk_profile.options, function(index, option) {
                    // Translate
                    sub += dhlparcel_shipping_bulk_profile_translations.options[option.toString().toUpperCase().trim()];
                    if (bulk_profile.required_options.includes(option)) {
                        sub += '*';
                    }
                    if (bulk_profile.options.length > index+1) {
                        sub += ', ';
                    }
                });
                sub = sub.trim() + ')';
            }

            var template = dhlparcel_shipping_bulk_profile_menu_template.split('REPLACE_ID').join('dhlparcel_shipping_bulk_code_' + bulk_profile.code);
            template = template.split('REPLACE_CODE').join(bulk_profile.code);
            template = template.split('REPLACE_VALUE').join(bulk_profile.code);
            template = template.split('REPLACE_TEXT').join(text);
            template = template.split('REPLACE_SUB').join(sub);

            $('#dhlparcel_shipping_settings_bulk_profile_add_container').before(template);

            if (bulk_profile.code === $('#dhlparcel_shipping_settings_bulk_profile_form_container').data('bulk-profile-code')) {
                $('#dhlparcel_shipping_bulk_code_' + bulk_profile.code).prop('checked', true);
            }
        });

    }).on('click', '#dhlparcel_shipping_settings_bulk_profile_add', function(e) {
        e.preventDefault();

        var save_profile = {
            code: Math.random().toString(36).substr(2, 9),
            country: dhlparcel_shipping_bulk_default_shipping_country,
            business: '',
            delivery: '',
            options: [],
            required_options: [],
            size: 'smallest'
        };

        var bulk_profiles_json = null;
        try {
            bulk_profiles_json = JSON.parse($('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val());
        } catch (e) {
            // Stop loading if not a valid JSON and reset
            bulk_profiles_json = [];
        }

        try {
            bulk_profiles_json.push(save_profile);
            $('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val(JSON.stringify(bulk_profiles_json));

            $(document.body).trigger('dhlparcel_shipping:clean_bulk_profile_template');
            $(document.body).trigger('dhlparcel_shipping:fill_bulk_profile_template');
        } catch (e) {
            // An unknown error has occured when adding bulk profile. This is a safety catch, but otherwise does nothing
        }

        $("#dhlparcel_shipping_bulk_code_" + save_profile.code).prop('checked', true);
        $("#dhlparcel_shipping_bulk_code_" + save_profile.code).trigger('change');

    }).on('click', '.dhlparcel_shipping_setting_bulk_profile_remove', function(e) {
        e.preventDefault();
        var profile_code = $(this).data('bulk-profile-code');

        try {
            // Find
            var bulk_profiles_json = JSON.parse($('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val());

            $.each(bulk_profiles_json, function (index, bulk_profile_json) {
                if (bulk_profile_json.code === profile_code) {
                    bulk_profiles_json.splice(index, 1);
                    return false; // break each loop
                }
            });

            // Save
            $('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val(JSON.stringify(bulk_profiles_json));
        } catch (e) {
            // Stop loading if not a valid JSON
        }

        $('#dhlparcel_shipping_settings_bulk_profile_form_unavailable').show();
        $('#dhlparcel_shipping_settings_bulk_profile_form_container').data('bulk-profile-code', null);
        $('#dhlparcel_shipping_settings_bulk_profile_form_container').hide();

        $(document.body).trigger('dhlparcel_shipping:clean_bulk_profile_template');
        $(document.body).trigger('dhlparcel_shipping:fill_bulk_profile_template');

    }).on('change', '.dhlparcel_shipping_bulk_profile_setting_form input, .dhlparcel_shipping_bulk_profile_setting_form select', function(e) {
        $(document.body).trigger('dhlparcel_shipping:save_bulk_profile');
        if ($(this).attr('id') === 'dhlparcel_shipping_sbpf_country' ||
            $(this).attr('id') === 'dhlparcel_shipping_sbpf_shipment_type' ||
            $(this).attr('id') === 'dhlparcel_shipping_sbpf_delivery_type') {

            // Need to refresh
            var search_code = $('#dhlparcel_shipping_settings_bulk_profile_form_container').data('bulk-profile-code');
            $(document.body).trigger('dhlparcel_shipping:refresh_bulk_profile_template', [search_code]);
        }

    }).on('dhlparcel_shipping:save_bulk_profile', function(e, reset = false) {
        var code = $('#dhlparcel_shipping_settings_bulk_profile_form_container').data('bulk-profile-code');
        var bulk_profiles = [];

        try {
            var bulk_profiles_json = JSON.parse($('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val());

            $.each(bulk_profiles_json, function (index, bulk_profile_json) {
                var bulk_profile = {
                    code: bulk_profile_json.code,
                    country: bulk_profile_json.country,
                    business: bulk_profile_json.business,
                    delivery: bulk_profile_json.delivery,
                    options: bulk_profile_json.options,
                    required_options: bulk_profile_json.required_options,
                    size: bulk_profile_json.size
                };
                bulk_profiles.push(bulk_profile);
            });

        } catch (e) {
            // Stop loading if not a valid JSON
        }


        var selected_options = [];
        var selected_roptions = [];

        if (!reset) {
            $("input[name='dhlparcel_shipping_service_options[]']:checked").each(function () {
                var selected_option = $(this).val().toString();
                selected_options.push(selected_option);
            });

            $("input[name='dhlparcel_shipping_service_roptions[]']:checked").each(function () {
                var selected_roption = $(this).val().toString();
                selected_roptions.push(selected_roption);
            });
        }

        var save_profile = {
            country: $('#dhlparcel_shipping_sbpf_country').val(),
            business: $('#dhlparcel_shipping_sbpf_shipment_type').val(),
            delivery: reset ? '' : $('#dhlparcel_shipping_sbpf_delivery_type').val(),
            options: selected_options,
            required_options: selected_roptions,
            size: reset ? 'smallest' : $('#dhlparcel_shipping_sbpf_size').val()
        };

        // Fix any broken parts (set to defaults)
        if (save_profile.country === null) {
            save_profile.country = dhlparcel_shipping_bulk_default_shipping_country;
        }
        if (save_profile.business === null) {
            save_profile.business = '';
        }
        if (save_profile.delivery === null) {
            save_profile.delivery = '';
        }
        if (save_profile.size === null) {
            save_profile.size = 'smallest';
        }

        var found = false;
        if (typeof code !== 'undefined') {
            $.each(bulk_profiles, function (index, bulk_profile) {
                if (bulk_profile.code === code) {
                    save_profile.code = code;
                    bulk_profiles[index] = save_profile;
                    found = true;
                }
            });
        }

        if (found !== true) {
            // Cannot save because code is not found

            // save_profile.code = Math.random().toString(36).substr(2, 9);
            // $('#dhlparcel_shipping_settings_bulk_profile_form_container').data('bulk-profile-code', save_profile.code);
            // bulk_profiles.push(save_profile);
        }

        $('input#DHLPARCEL_SHIPPING_BULK_PROFILES_DATA').val(JSON.stringify(bulk_profiles));

        $(document.body).trigger('dhlparcel_shipping:clean_bulk_profile_template');
        $(document.body).trigger('dhlparcel_shipping:fill_bulk_profile_template');

    }).on('change', "#dhlparcel_shipping_settings_bulk_profile_form_container input[name='dhlparcel_shipping_service_roptions[]']", function() {
        if ($(this).is(':checked') && !$("input.dhlparcel_shipping_panel_service_option[value='" + $(this).val() + "']").is(':checked')) {
            $("input.dhlparcel_shipping_panel_service_option[value='" + $(this).val() + "']").attr('checked', true);
            $("input.dhlparcel_shipping_panel_service_option[value='" + $(this).val() + "']").trigger("change");
        }

    }).on('change', "#dhlparcel_shipping_settings_bulk_profile_form_container input[name='dhlparcel_shipping_service_options[]']", function() {
        // Uncheck required if this is unchecked as well
        if (!$(this).is(':checked') && $("input.dhlparcel_shipping_panel_service_roption[value='" + $(this).val() + "']").is(':checked')) {
            $("input.dhlparcel_shipping_panel_service_roption[value='" + $(this).val() + "']").attr('checked', false);
        }

        // Reset services
        $("#dhlparcel_shipping_panel_service_options :input").each(function() {
            $(this).attr('disabled', false);
        });

        $(document.body).trigger('dhlparcel_shipping:disable_settings_service_option_exclusions');

    }).on('dhlparcel_shipping:disable_settings_service_option_exclusions', function() {
        var disable_options_collection = [];
        $("#dhlparcel_shipping_panel_service_options :input:checked").each(function() {
            disable_options = $(this).data('exclusions');
            $.each(disable_options, function (index, value) {
                disable_options_collection.push(value.toString());
            });
        });

        $.each(disable_options_collection, function (index, value) {
            $("#dhlparcel_shipping_panel_service_options :input[value='" + value + "']:checked").attr('checked', false);
            $("#dhlparcel_shipping_panel_service_options :input[value='" + value + "']:enabled").attr('disabled', true);
        });

    }).on('dhlparcel_shipping:add_shipping_method_jump_button', function(e) {
        if ($('#DHLPARCEL_SHIPPING_SHIPPING_METHOD_JUMP_BUTTON').length > 0) {
            $('#DHLPARCEL_SHIPPING_SHIPPING_METHOD_JUMP_BUTTON')
                .closest('.form-group')
                .removeClass('hide')
                .html(dhlparcel_shipping_shipping_method_jump_template);
        }

    }).on('click', '#dhlparcel_shipping_settings_shipping_method_jump', function(e) {
        e.preventDefault();

        var dhlparcel_shipping_window = window.open(dhlparcel_shipping_shipping_method_jump_link, '_blank');
        if (dhlparcel_shipping_window) {
            dhlparcel_shipping_window.focus();
        } else {
            window.location.href = dhlparcel_shipping_shipping_method_jump_link;
        }

    }).on('dhlparcel_shipping:add_shipping_method_payment_button', function(e) {
        if ($('#DHLPARCEL_SHIPPING_SHIPPING_METHOD_PAYMENT_BUTTON').length > 0) {
            $('#DHLPARCEL_SHIPPING_SHIPPING_METHOD_PAYMENT_BUTTON')
                .closest('.form-group')
                .removeClass('hide')
                .html(dhlparcel_shipping_shipping_method_payment_template);
        }

    }).on('click', '#dhlparcel_shipping_settings_shipping_method_payment', function(e) {
        e.preventDefault();

        var dhlparcel_shipping_window = window.open(dhlparcel_shipping_shipping_method_payment_link, '_blank');
        if (dhlparcel_shipping_window) {
            dhlparcel_shipping_window.focus();
        } else {
            window.location.href = dhlparcel_shipping_shipping_method_payment_link;
        }

    }).on('dhlparcel_shipping:add_shipping_method_reset_button', function(e) {
        if ($('#DHLPARCEL_SHIPPING_SHIPPING_METHOD_RESET_BUTTON').length > 0) {
            $('#DHLPARCEL_SHIPPING_SHIPPING_METHOD_RESET_BUTTON')
                .closest('.form-group')
                .removeClass('hide')
                .html(dhlparcel_shipping_shipping_method_reset_template);
        }

    }).on('click', '#dhlparcel_shipping_settings_shipping_method_reset', function(e) {
        e.preventDefault();

        if (confirm(dhlparcel_shipping_shipping_method_reset_message)) {
            $.post(dhlparcel_shipping_shipping_method_reset_link, [], function (response) {
                try {
                    var message = response.message;
                } catch (error) {
                    alert('Error');
                    return;
                }

                alert(message);
            });
        }
    }).on('dhlparcel_shipping:shipping_update_custom_reference', function () {
        var toggle_reference = $('select#DHLPARCEL_SHIPPING_AUTO_DEFAULT_REFERENCE').val() === '3'
        $('input#DHLPARCEL_SHIPPING_AUTO_DEFAULT_REFERENCE_CUSTOM').parents('.form-group').toggle(toggle_reference)

        var toggle_reference2 = $('select#DHLPARCEL_SHIPPING_AUTO_DEFAULT_REFERENCE2').val() === '3'
        $('input#DHLPARCEL_SHIPPING_AUTO_DEFAULT_REFERENCE2_CUSTOM').parents('.form-group').toggle(toggle_reference2)

    }).on('change', 'select.dhlparcel_shipping_service_option_reference', function () {
        $(document.body).trigger('dhlparcel_shipping:shipping_update_custom_reference');
    }).on('dhlparcel_shipping:shipping_address_set_required_housenumber', function (event, value) {
        var emptyHousenumberCountries = [
            'FR',
            'IE',
            'PT',
            'ES',
            'GB',
        ];
        if ($.inArray(value, emptyHousenumberCountries) !== -1) {
            $('#DHLPARCEL_SHIPPING_SHIPPING_ADDRESS_STREET_NUMBER')
                .removeAttr('required')
                .parent()
                .siblings('.control-label')
                .removeClass('required');
        } else {
            $('#DHLPARCEL_SHIPPING_SHIPPING_ADDRESS_STREET_NUMBER')
                .attr('required', 'required')
                .parent()
                .siblings('.control-label')
                .addClass('required');
        }
    }).on('change', '#DHLPARCEL_SHIPPING_SHIPPING_ADDRESS_COUNTRY', function () {
        $(document.body).trigger('dhlparcel_shipping:shipping_address_set_required_housenumber', $(this).val());
    });

    $(document.body).trigger('dhlparcel_shipping:add_test_authenticate_button');
    $(document.body).trigger('dhlparcel_shipping:set_ccc_mode');
    $(document.body).trigger('dhlparcel_shipping:add_bulk_subtitle');
    $(document.body).trigger('dhlparcel_shipping:init_bulk_profile_template');
    $(document.body).trigger('dhlparcel_shipping:add_shipping_method_jump_button');
    $(document.body).trigger('dhlparcel_shipping:add_shipping_method_payment_button');
    $(document.body).trigger('dhlparcel_shipping:add_shipping_method_reset_button');
    $(document.body).trigger('dhlparcel_shipping:shipping_update_custom_reference');
    $(document.body).trigger('dhlparcel_shipping:shipping_address_set_required_housenumber', $('#DHLPARCEL_SHIPPING_SHIPPING_ADDRESS_COUNTRY').val());
});
