<?php

namespace DHLParcel\Shipping\Controller\BackOffice;

use DHLParcel\Shipping\Model\Service\LabelService;
use DHLParcel\Shipping\Model\Core\TranslateTrait;
use PrestaShopBundle\Controller\Admin\FrameworkBundleAdminController;
use Tools;
use Context;

class DownloadController extends FrameworkBundleAdminController
{
    use TranslateTrait;

    public function pdfAction()
    {
        $labelId = Tools::getValue('file');
        if (!is_string($labelId) || !preg_match('/^[a-f\d]{8}(-[a-f\d]{4}){4}[a-f\d]{8}$/i', $labelId)) {
            echo 'invalid file';
            return;
        }

        $label = LabelService::instance()->getLabelData($labelId);
        if (!$label) {
            echo 'label not found';
            return;
        }

        if (!$pdf = base64_decode($label->pdf)) {
            echo 'error decoding';
            return;
        }

        $filename = 'dhlparcel-shipping-label.pdf';
        header('Content-type: application/pdf');
        header('Content-Disposition: attachment; filename="' . $filename . '"');
        header('Cache-Control: must-revalidate');
        echo $pdf;
    }

    public function pdfsAction()
    {
        $orderIds = Tools::getValue('order_ids') ?: [];

        $labels = [];
        foreach ($orderIds as $orderId) {
            $labels = array_merge($labels, LabelService::instance()->getAll($orderId));
        }

        $labelIds = [];
        foreach ($labels as $label) {
            $labelIds[] = $label->label_uuid;
        }

        $pdf = LabelService::instance()->requestMultiPDF($labelIds);
        if (!$pdf) {
            echo 'labels not found';
            return;
        }

        $filename = 'dhlparcel-shipping-labels.pdf';
        header('Content-type: application/pdf');
        header('Content-Disposition: inline; filename="' . $filename . '"');
        header('Cache-Control: must-revalidate');
        echo $pdf;
    }
}
